#include <fstream>
using namespace std;
// binary search tree node
template <typename T>
class BSTnode
{    public:
		T nodeValue;			// data held by the node
		BSTnode<T> *left;		// pointer to left subtree
		BSTnode<T> *right;		// pointer to the right subtree
	
		// default constructor with no initial value
		BSTnode( )
		{
			left = NULL;
			right = NULL;
		}
		// constructor initializes nodeValue and next
		BSTnode(const T& item, BSTnode<T> *l = NULL, BSTnode<T> *r=NULL): 
			nodeValue(item), left(l), right(r)
		{	
			nodeValue = item;
			left = l;
			right = r;
		}
		void print(ostream & ostr)
		{	
			nodeValue.print(ostr);
		}
};
